class WordEditor( oParent ) of Editor( oParent ) custom
  
  /*
  Aufrufe von "ausserhalb" des Editors z. B. mit
  
  form.editor.key(18)
  form.editor.keyboard("{CTRL+R}")
  */
  
  
  // Hinweis auf Tastenkombination als Speedtip anzeigen
  function onOpen
    #define STATE_BROWSE   1
    
    
    /*
    Wenn der Editor im Designer auf eine Form gezogen wird,
    verursacht die Prfung auf rowset.state einen Fehler
    (da ja noch kein datalink gesetzt ist).
    Daher in try ... catch "einwickeln"
    */

    try
      /*
      this     = Editor
      datalink = Memofeld
      parent   = Fields-Array
      parent   = Rowset
      */
      if this.datalink.parent.parent.state <> STATE_BROWSE   // nur wenn in Bearbeitungsmodus
        this.speedtip := "Strg+R - Rechtschreibung prfen"
      endif
    catch (exception e)
    endtry
  return
  
  
  
  
  function key(nChar)
    /*
    This code adapted from original message in
    dbase.watercooler at 12.07.2000 from Paul Van House
    */
    
    // Rechtschreibprfung mit Strg+R starten
    if nChar == 18 and len(this.value.righttrim()) > 0
      
      // kann MS Word gestartet werden?
      local lChooseWord
      lChooseWord = true
      private oWord
      try
        oWord=new oleautoclient("word.application")
      catch (exception e)
        if type('oWord') = 'O'
          release object oWord
          oWord = null
        endif
        lChooseWord = false
      endtry
      
      if lChooseWord
        //MS Word ist vorhanden
        
        // neues Dokument ffnen
        oWord.documents.add("normal.dot", false)
        
        // Text aus Editor in Dokument einfgen
        oWord.selection.text := this.value
        
        // Word sichtbar machen
        oWord.visible := true
        
        // Word Rechtschreibprfung starten
        oWord.activedocument.checkspelling()
        
        // Rechtschreibprfung fertig - Word wieder verstecken
        oWord.visible := false
        
        // kompletten Text im Dokument markieren ...
        oWord.activedocument.select()
        
        // ... und in Zwischenablage kopieren
        oWord.selection.copy()
        
        // Inhalt des Editors lschen
        this.value := ""
        
        // Fokus auf Editor setzen
        this.setfocus()
        
        // Inhalt der Zwischenablage in Editor einfgen
        this.paste()
        
        // kleiner Workaround, damit der Inhalt auch erhalten bleibt
        this.value := this.value
        
        // Aufrumarbeiten:
        // Word beenden
        oWord.quit(false)
        
        // Objekt lschen ...
        release object oWord
        
        // ... und Variable lschen
        oWord = null
      endif
      
      // keinen Tastendruck an Editor liefern
      return false
    endif
    
  return true
endclass
